import adonthell

#
# ------ helpers -------
#

# -- print inventories
def print_inventories (inventories):
    for inv in inventories:
        slot = inv.first ()
        num = 0
        while slot != None:
            num = num + 1
            if slot.count () == 0: print "%s is empty" % slot.id ()
            else: 
                item = slot.get_item ()
                print "%s contains %i item(s): %s" % (slot.id (), slot.count (), item.name ())
                if not item.is_mutable (): item.set_slot (None)
            slot = inv.next ()
        print "-------------------"


#
# ------ setup -------
#

# -- init manager
Manager = adonthell.manager ()

Manager.add_mapping ("Left Hand", "One-Handed")
Manager.add_mapping ("Left Hand", "Shield")
Manager.add_mapping ("Right Hand", "Weapon")
Manager.add_mapping ("Right Hand", "Tool")
Manager.add_mapping ("Quiver", "Projectile")

# -- create equipment inventory
inv = adonthell.inventory (0, 1)
inv.add_slot ("Left Hand", 1)
inv.add_slot ("Right Hand", 1)
inv.add_slot ("Quiver", 1)

# -- create some items

# -- immutable items
Arrow = adonthell.item_base (0)
Arrow.set_max_stack (50)
Arrow.create_instance ("item.projectile", "projectile")

pyitem = Arrow.get_instance ()
pyitem.Name = "Arrow"
pyitem.this = Arrow

adonthell.item_storage_add (Arrow)

# -- mutable item
Sword = adonthell.item_base (1)
Sword.set_max_stack (1)
Sword.create_instance ("item.weapon", "weapon")

pyitem = Sword.get_instance ()
pyitem.add_category ("One-Handed")
pyitem.Name = "Sword"
pyitem.this = Sword

#
# ----- test code below ------
#

# -- equip sword in left hand
LeftHand = inv.get_slot ("Left Hand")
Manager.equip (LeftHand, Sword, 1)
print_inventories ([inv])

# -- move sword to right hand
RightHand = inv.get_slot ("Right Hand")
Manager.equip (RightHand, LeftHand.get_item (), 1)
print_inventories ([inv])

# -- try to add sword to quiver
Quiver = inv.get_slot ("Quiver")
Manager.equip (Quiver, RightHand.get_item (), 1)
print_inventories ([inv])

# -- add some arrows to the quiver
Manager.equip (Quiver, Arrow, 45)
print_inventories ([inv])

# -- unequip some arrows
item, count = Manager.unequip (Quiver, 15)
print_inventories ([inv])
print "I also have %i %ss here\n" % (count, item.get_instance ().Name)

# -- put them back
Manager.equip (Quiver, item, count)
print_inventories ([inv])
